VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFC0C0&
   Caption         =   "Form1"
   ClientHeight    =   3045
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6345
   LinkTopic       =   "Form1"
   ScaleHeight     =   203
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   423
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdNewGame 
      Caption         =   "New Game"
      Height          =   495
      Left            =   0
      TabIndex        =   2
      Top             =   2400
      Width           =   2295
   End
   Begin VB.Label Label2 
      BackColor       =   &H00FFC0C0&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Label2"
      Height          =   735
      Left            =   3000
      TabIndex        =   1
      Top             =   1440
      Width           =   3255
   End
   Begin VB.Label Label1 
      BackColor       =   &H00FFC0C0&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Label1"
      Height          =   735
      Left            =   3000
      TabIndex        =   0
      Top             =   0
      Width           =   3255
   End
   Begin VB.Line Line1 
      BorderWidth     =   5
      X1              =   192
      X2              =   192
      Y1              =   152
      Y2              =   184
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'By oigres P (sergio Perciballi); Email oigres@postmaster.co.uk
'Object-oriented game
'Warning--This might not be the best object design
'Game rules from Edward De Bono
'-Spot Game US Patent 5,5076,494 patents pending in other countries
'Rules on web page
'http://www.edwdebono.com/debono/3spot.htm
'
'Red or blue scores on yellow squares
'Objective-The object isto score 12 points provided that the other player
'scores at least 6 points- ifthe other player scores less
' thansix points then the player reaching 12 points is the looser!
'I assumed no diagonal moves
'Bug update in rule object (16-Oct-2000) in checkwinner()
'Game creates rules,blocks and board
Dim game As cGame
Dim mousedown As Boolean
Dim mousex As Long, mousey As Long 'start X1,Y1
Dim endx As Long, endy As Long 'last mouse pos X2,Y2
Dim lastmousex As Long, lastmousey As Long
Dim vmove(3) As Long '0-3

Private Sub cmdNewGame_Click()
    'new game or reset;start over
    gameStart
   
End Sub


Private Sub Form_Load()
    Form1.Move Form1.width - (Form1.width \ 2), Form1.Height - (Form1.Height \ 2)
    gameStart

    Form1.AutoRedraw = True
    Form1.FillColor = &H0&

    mousedown = False
End Sub

Private Sub gameStart()
    Line1.Visible = False
    Set game = Nothing
    Set game = New cGame
    game.start

End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim w As Long
    Dim mx, my
    'Dim w As Long
    With game
        'if someone has won
        If .rule.winner = True Then Exit Sub
        w = .cb.Bwidth
        mx = x \ w
        my = y \ w
        If mx > 2 Or my > 2 Then Exit Sub
        mousedown = True
        mousex = x \ w
        mousey = y \ w
        .rule.thisblock.eraseblock .cb
        ''
        Line1.BorderColor = .rule.thisblock.colour
        Line1.Visible = True
        Line1.X1 = mousex * w + (w \ 2)
        Line1.Y1 = mousey * w + (w \ 2)
    End With
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim mx, my
    Dim w As Long
    'if someone has won
    If game.rule.winner = True Then Exit Sub
    w = game.cb.Bwidth
    mx = x \ w
    my = y \ w
    If mx > 2 Or my > 2 Then Exit Sub
    Form1.Caption = "X=" & mx & ":Y=" & my
    'stop diagonal move
    If (mx <> mousex) And (my <> mousey) Then Exit Sub
    
    If mousedown = True Then
        'can't have more than 2 squares long
        If Abs(mousex - mx) >= 2 Then Exit Sub
        If Abs(mousey - my) >= 2 Then Exit Sub
        ''Debug.Print Abs(mousex - mx); Abs(mousey - my)
        Line1.X2 = mx * w + (w \ 2)
        Line1.Y2 = my * w + (w \ 2)
        'validate move

        vmove(0) = mousex
        vmove(1) = mousey
        vmove(2) = mx
        vmove(3) = my

    End If

End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    'if validmove then get next block ;red,white,blue;red;white,blue
    Dim returnvalue As Variant
    Dim mx, my
    Dim w As Long
    mousedown = False
    With game
        'if someone has won
        If .rule.winner = True Then Exit Sub
        w = .cb.Bwidth
        mx = x \ w
        my = y \ w
        
        ''Debug.Print mousex; mousey; mx; my
        'outside of grid
        If mx > 2 Or my > 2 Then
            .cb.draw
            .blockR.draw .cb
            .blockW.draw .cb
            .blockB.draw .cb
            Line1.Visible = False
            Exit Sub
        End If
        
        If Abs(mousex - mx) = 0 And Abs(mousey - my) = 0 Then
            .cb.draw
            .blockR.draw .cb
            .blockW.draw .cb
            .blockB.draw .cb
            Line1.Visible = False
            Exit Sub
        End If
        
        returnvalue = .rule.isValidMove(vmove(), .cb, .rule.thisblock)  'getNextBlock(blockR, blockW, blockB))

        'score the move
        If returnvalue = True Then
            'need to delete old board pieces
            ReDim v1(3) As Long
            v1 = .rule.thisblock.getBlockpoints
            .cb.letpointBoard v1(0), v1(1), ""
            .cb.letpointBoard v1(2), v1(3), ""
            .rule.thisblock.letBlockpoints vmove()

            .cb.letpointBoard vmove(0), vmove(1), .rule.thisblock.tag
            .cb.letpointBoard vmove(2), vmove(3), .rule.thisblock.tag
            .cb.draw
            .blockR.draw .cb
            .blockW.draw .cb
            .blockB.draw .cb

            .rule.thisblock.draw .cb
            .rule.score vmove(), .rule.thisblock
            'see if we have a winner
            ReDim str(1) As String
            str = .rule.results
            If str(0) <> "" Or str(1) <> "" Then
                Label2.Caption = str(0) & vbCrLf & str(1) '"Winner is "
                Exit Sub
            End If
            .rule.getNextBlock .blockR, .blockW, .blockB
        Else
            .cb.draw
            .blockR.draw .cb
            .blockW.draw .cb
            .blockB.draw .cb
            Line1.Visible = False
        End If
        Label2.Caption = "The next block to move is  " & .rule.thisblock.tag
        Select Case AscW(.rule.thisblock.tag & Chr$(0))
        Case 82 '"R"
            Label2.Caption = Label2.Caption & "ed"
        Case 66 '"B"
            Label2.Caption = Label2.Caption & "lue"
        Case 87 '"W"
            Label2.Caption = Label2.Caption & "hite"
        End Select
    End With
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set game = Nothing
  
End Sub
